



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《Inside C#》笔记(十五) 非托管代码 上</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《Inside C#》笔记(十五) 非托管代码 上</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 13:11:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>为了保证向后兼容性，C#和.NET可以通过非托管的方式运行旧代码。非托管代码是指没有被.NET运行时管控的代码。非托管代码主要包括：平台调用服务(PlatformInvocation Services)、不安全代码(Unsafe Code)、COM互操作(COM interoperability)。</p>
<p><strong>&nbsp;</strong></p>
<p><strong>一 平台调用服务</strong></p>
<p>平台调用服务(Platform Invocation Services)也被称作PInvoke，可以使用非托管DLL中的方法、结构甚至是给其传递回调函数。在使用非托管DLL前需事先了解DLL内部方法的参数和返回值。</p>
<p>a)基本使用方法为：</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpXMAwg5QUuvs9sibeYQRXYPcibKPftZryD8ROgBbFDqefe3sqBdLp7HicA/0?wx_fmt=png" /></p>
<p>MessageBoxA属于Win32的API，需要先声明一个与MessageBoxA的方法签名一致的方法，然后DllImport导入这个DLL，签名方法必须用static extern修饰。</p>
<p>b)签名方法也可与DLL中的方法不同名，但需在DllImport的EntryPoint指定原始名称。</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpeiaibLAkmnQUxLJib8IQFoc5pxOkUHTQ64liaBu9zHUcutibKsicVsffWHOw/0?wx_fmt=png" /></p>
<p>c)使用CharSet</p>
<p>CharSet可以指定DLL所使用的字符集。比如上述的MessageBoxA实际上对应的是Ansi编码，还有对应Unicode编码的MessageBoxW，除了直接指定调用哪个，还可用下面的写法：</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpZPdSV3icgqicIsOqibqHHjnKKsSMFfD3gickKKtAqsbGakFWHtrhl04tfw/0?wx_fmt=png" /></p>
<p>编译器会根据CharSet的类型决定调用哪种MessageBox。这应该需要DLL内部做相应配合，至少需要知道每个MessageBox对应的字符集。</p>
<p>d)回调</p>
<p>不仅C#代码可以调用DLL的方法，DLL方法也可用回调的方式使用C#代码。</p>
<p>这里将PrintWindow作为回调函数传递给了API中的EnumWindows方法。</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpCs78EAM5GLiaF66mmDZPjwQFicQwCjXS6AZ6iannn49XMdmb686iaLDHdw/0?wx_fmt=png" /></p>
<p>e)Marshal（排列、整理？）</p>
<p>在前面的例子中，DLL中MessageBox的方法参数为：</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpB2qJgs9cmVdpwG4yeUcw7pvsvHjvsCMdbdyWXPQGOI4Q9ABXzDOmrw/0?wx_fmt=png" /></p>
<p>C#代码中的方法签名并没有与之完全匹配，但却能正常运行，这是因为编译器自动进行了默认的Marshal，比如将C#的string类型对应为Win32的LPSTR。这个过程也可以手动进行，使用MarshalAs：</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmp7rorWzPZlm1V7c4azwzKjgFIbGL5TibgDnp0iaLtxgF7xjVBvD8wFDxw/0?wx_fmt=png" /></p>
<p>​</p>
<p>如果要Marshal返回值，要标记在方法体上面。</p>
<p><strong>二 编写不安全代码</strong></p>
<p>这里的不安全代码指的是没有被.NET运行时托管的代码，内存的分配、释放、寻址等都不受约束，比如可以在C#代码中使用指针，在有些场合C#指针非常有用，比如需要调用C语言编写的API时、或者需要对内存有完全的控制时。</p>
<p>a)与不安全代码相关的关键字unsafe和fixed</p>
<p>unsafe关键字用来告知.NET运行时，相关的代码块将不受托管。不受托管的代码块可以是方法、属性、或者是一个方法内部的代码片段。</p>
<p>fix关键字用来&ldquo;钉&rdquo;(pinning)住某个对象，这样GC就不会尝试对其回收了。但对象在内存的地址不会被固定，地址仍然会被运行时浮动，以避免出现内存碎片。因为地址不固定，所以这时使用指针就要小心了。</p>
<p>b)在C#中使用指针</p>
<p>C#中的指针比较特殊：只能指向值类型、数组、字符串；如果指针指向数组，数组的第一个元素必须是值类型，因为指针实际上要指向的是这个数组的第一个元素；</p>
<p>C#中的指针相关的运算符与C、C++一样：&amp;，取得某个对象的地址; *，取得对象的值; -&gt;，取得对象中某个成员的值。简单示例为：</p>
<p><img referrerpolicy="no-referrer"src="https://mmbiz.qlogo.cn/mmbiz_png/93vVribQAXSRPXgTyrT0jx9r5umzXBSmpbSHX7kS0bKNrqTVLXZwk30Qn9IEQLGumupPYDQDTUibO0ZjzgibSlHTQ/0?wx_fmt=png" /></p>
<p>编译标记为unsafe的代码前，需要在项目属性中设置允许不安全代码。</p>
<p>学习资料：Inside C# by Tom Archer</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p6wkqx.html">Python标准模块--os</a>
		</li>
						<li><a href="https://www.batexi.com/a/495x54z8.html">MAC OS升级到10&period;11&lpar;OS X EICAPTION&rpar;之后CocoaPods不能正常使用的问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gd4079.html">CCNA网络基础（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj21v8.html">EasyUI&lowbar;Datagrid学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvo108.html">ik分词</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnyxl9.html">tomcat 7 无法打开管理页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6v2y9.html">PHP CI框架最近学到的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjj51k8.html">Android 屏幕实现水龙头事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mergx6q.html">thinkphp实现文件的下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jn3ll8.html">loading加载动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojp7opq.html">机器学习技法：07 Blending and Bagging</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mo6m48.html">JavaScript入门学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jvke9.html">Linux中python3&comma;django&comma;redis以及mariab的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwdp178.html">读取tensorflow的checkpoint里保存的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyd3mx9.html">Java冒泡具体的原理，以及下标的变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3jol9.html">my97date 时间范围限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpg03e9.html">Kafka网络模型分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkejkx8.html">CodeForces 985D Sand Fortress</a>
		</li>
						<li><a href="https://www.batexi.com/a/95323568.html">&lbrack;BZOJ1185&rsqb;&lbrack;HNOI2007&rsqb;最小矩形覆盖-&lbrack;凸包&plus;旋转卡壳&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvm432q.html">51 nod 1109 01组成的N的倍数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv236p19.html">机器学习技法笔记：05 Kernel Logistic Regression</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1lzzeq.html">Spring Boot日志集成实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dkpg9.html">redis epoll 原理梗概</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3eznq.html">&lbrack;EXP&rsqb;McAfee ePO 5&period;9&period;1 - Registered Executable Local Access Bypass</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv23geo9.html">RabbitMQ常见错误2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xeyrq.html">Docker构建Java web应用服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv272l19.html">jquery插入&comma;复制、替换和删除节点</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6pjrq.html">【CSS学习】--- z-index属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zylk039.html">手撕coreML之yolov2 object detection物体检测（含源代码）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xdkpq.html">SpringBoot之Mybatis操作中使用Redis做缓存</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
